/*===================================================================
 * Copyright(c) AVerMedia TECHNOLOGIES, Inc. 2017
 * All rights reserved
 * =================================================================
 * typedef.h
 *
 *  Created on: Apr 15, 2017
 *      Author: 
 *      Version:
 * =================================================================
 */

#ifndef RX_SHARE_H
#define RX_SHARE_H

#ifdef __cplusplus
extern "C" {
#endif

#define PROGRESS  0
#define INTERLACE 1

#define Vneg      0
#define Hneg      0
#define Vpos      1
#define Hpos      1

#define RGBF_to_BT709   0
#define RGBL_to_BT709   1
#define RGBF_to_BT601   2
#define RGBL_to_BT601   3
#define RGBF_to_BT2020  4  
#define RGBL_to_BT2020  5
#define RGBL_to_RGBF    6
#define RGB2020F_to_RGB709F 7 // n380

#define BT709_to_RGBF   0
#define BT709_to_RGBL   1
#define BT601_to_RGBF   2
#define BT601_to_RGBL   3

#define BT601_to_BT709  4
#define BT709_to_BT601  5

#define BT601_to_BT2020 6                
#define BT709_to_BT2020 7
#define BT2020_to_RGBF  8
#define BT2020_to_RGBL  9
#define BT2020_to_BT709 0xa
#define BT2020_to_BT601 0xb
#define BT_BYPASS_MODE  0xc

#define BI_RGB3 11
#define BI_BGR3 12

//Add audio output sample bits function.
#define RX_AUD_24_BITS	0x00
#define RX_AUD_20_BITS	0x01
#define RX_AUD_16_BITS	0x02
#define RX_AUD_DEF_BITS	0x02

#define AUDIO_32K		320000
#define AUDIO_44K		441000
#define AUDIO_48K		480000
#define AUDIO_88K		882000
#define AUDIO_96K		960000
#define AUDIO_176K		1764000
#define AUDIO_192K		1920000
#define AUDIO_TOLERANCE	50000

//[RD3-148]+
#define AviInfoFrameRgbLimitedRange 0
#define AviInfoFrameRgbFullRange 1
#define AviInfoFrameUnknownRgbRange 2
//[RD3-148]-

enum eWorkingModeRX
{
    RX_480_MODE,
    RX_720_MODE,
    RX_4k2k_MODE,
};

typedef enum{
	RX_AUDIO_RATE_32000, //0
	RX_AUDIO_RATE_44100, //1
	RX_AUDIO_RATE_48000, //2
	RX_AUDIO_RATE_88200,
	RX_AUDIO_RATE_96000,
	RX_AUDIO_RATE_176400,
	RX_AUDIO_RATE_192000,
}rx_audio_sample;

typedef enum 
{
    RX_OPMODE_PWRDWN = 0,
    RX_OPMODE_PWRUP,
    RX_OPMODE_HDMI,
    RX_OPMODE_COMP,
    RX_OPMODE_GR,
    RX_OPMODE_SDP_COMP,
    RX_OPMODE_SDP_CVBS,
    RX_OPMODE_SDP_CVBS_HDMI_MON,
    RX_OPMODE_SDP_CVBS_YC_AUTO,         /* Not available yet */
    RX_OPMODE_SDP_YC,
    RX_OPMODE_SDP_SCART
} RX_OP_MODE;


/*========================================
 * Analog Front End Defines and Macros
 *========================================*/
typedef enum 
{
    RX_ADC0 = 0,
    RX_ADC1,
    RX_ADC2,
    RX_ADC3,
    RX_SDP_ADC0,
    RX_SDP_ADC1,
    RX_SDP_ADC2,
    RX_SDP_ADC3,
    RX_ALL_ADCS
} RX_ADC;

typedef enum 
{
    RX_AIN1 = 1,
    RX_AIN2,
    RX_AIN3,
    RX_AIN4,
    RX_AIN5,
    RX_AIN6,
    RX_AIN7,
    RX_AIN8,
    RX_AIN9,
    RX_AIN10,
    RX_AIN11,
    RX_AIN12,
    RX_AIN13,
    RX_AIN_NONE
} RX_AIN_CH;

typedef enum 
{
    RX_HS_AUTO = 0,
    RX_HS_IN1,
    RX_HS_IN2,
    RX_HS_HDMI
} RX_HS_SEL;

typedef enum
{
    RX_SYNC_CH1 = 0,
    RX_SYNC_CH2
} RX_SYNC_CH;

typedef enum
{
    RX_VS_AUTO = 0,
    RX_VS_IN1,
    RX_VS_IN2,
    RX_VS_HDMI
} RX_VS_SEL;

typedef enum 
{
    RX_SYNC_AUTO = 0,
    RX_SYNC_1,
    RX_SYNC_2,
    RX_SYNC_3,
    RX_SYNC_4,
    RX_SOY,
    RX_SOG,
    RX_SYNC_LO
} RX_EMBSYNC_SEL;

typedef enum 
{
    RX_HS_VS = 1,
    RX_HS_CS,
    RX_EMB_SYNC,
    RX_AUTO_SYNC
} RX_SYNC_SRC;

typedef enum 
{
    RX_CP_CSC = 1,
    RX_DPP_CSC,
    RX_SDP_CSC
} RX_CSC;

typedef enum 
{
    RX_CS_AUTO_EN = 1,
    RX_CS_MAN_EN,
    RX_CS_MAN_DIS
} RX_CSC_MODE;

typedef enum 
{
    RX_CS_AUTO = 1,
    RX_CS_MAN
} RX_CSC_CONFIG;

typedef enum
{
    RX_VS_OUT_PIN = 1,
    RX_HS_OUT_PIN,
    RX_SYNC_OUT_PIN,
    RX_DE_OUT_PIN,
    RX_HS_IN1_PIN,
    RX_VS_IN1_PIN,
    RX_HS_IN2_PIN,
    RX_VS_IN2_PIN,
    RX_SDP_VS_OUT_PIN,
    RX_SDP_HS_OUT_PIN,
    RX_SDP_FIELD_OUT_PIN,
    RX_FIELD_OUT_PIN,
    RX_INT_OUT_PIN,
    RX_INT1_OUT_PIN,
    RX_INT2_OUT_PIN,
    RX_INT3_OUT_PIN,
    RX_CABLE_DET_PINS,
    RX_HPA_PINS,
    RX_HPA_A_PIN,
    RX_POWERDNB_PIN,
    RX_OUT_PINS,
    RX_LLC_OUT_PIN,
    RX_SYNC_OUT_PINS,   
    RX_PIX_OUT_PINS,
    RX_AUD_OUT_PINS,
    RX_SDP_OUT_PINS,
    RX_SDP_LLC_OUT_PIN,
    RX_MEM_IF_PINS,
    RX_SDP_PIX_OUT_PINS,
    RX_SDP_SYNC_OUT_PINS,
    RX_SPI_EPROM_PINS,
    RX_SPI_VDP_PINS,
    RX_MCLK_PIN,
    RX_SCLK_PIN,
    RX_TRI1_PIN,
    RX_TRI2_PIN,
    RX_TRI3_PIN,
    RX_TRI4_PIN,
    RX_TRI5_PIN,
    RX_TRI6_PIN,
    RX_TRI7_PIN,
    RX_TRI8_PIN
    
} RX_PIN;

typedef enum
{
    RX_DISABLE_PIN = 0,
    RX_ENABLE_PIN,
    RX_VS_SIG,  
    RX_HS_SIG,
    RX_SFL_SIG,
    RX_DE_SIG,
    RX_CS_SIG,
    RX_INT_SIG,
    RX_AUDIO_MUTE_SIG,
    RX_FIELD_SIG,   
    RX_TRILEVEL_SIG,
    RX_SYNC_OUT_SIG,
    RX_HP_SIG,
    RX_SCLK_SIG,
    RX_MCLK_SIG,
    RX_FB_SIG
} RX_PIN_FUNCTION;

typedef struct{
    U8_T	id_4x3;
    U8_T    id_16x9;
}MW_RX_CEA_ID;

typedef enum
{
    RX_PAL = 0,
    RX_NTSC,
    RX_PALNC,
    RX_PALM,
    RX_PALN,
    RX_PAL60,
    RX_N443,    
    RX_SECAM,
    RX_SECAM60,
    RX_240P,
    RX_288P,
    RX_UNDEF_SDP_FORMAT,
    RX_ALL_SDP_FORMATS
} RX_SDP_FORMAT;

typedef enum 
{
    RX_CS_RGB = 1,
    RX_CS_YCrCb601,
    RX_CS_YCrCb709,
    RX_CS_XVYCC601,
    RX_CS_XVYCC709,
    RX_CS_SYCC601,
    RX_CS_ADOBE_YCC601,
    RX_CS_ADOBE_RGB,
    RX_CS_FOLLOW_INPUT
} RX_CS_COLOR;

typedef enum {
    RX_RG_16_235,
    RX_RG_0_255,
    RX_RG_EXTENDED,
    RX_RG_AUTO
}RX_RANGE;

typedef enum 
{
    RX_BUS_BITS_8 = 0,
    RX_BUS_BITS_10,
    RX_BUS_BITS_12
} RX_BUS_BIT_WIDTH;

typedef enum 
{
    RX_BUS_MODE0 = 0,
    RX_BUS_MODE1,
    RX_BUS_MODE2,
    RX_BUS_MODE3,
    RX_BUS_MODE4,
    RX_BUS_MODE5
} RX_BUS_MODE;

typedef enum 
{
    RX_BUS_OP_MODE_422PSDR = 0,
    RX_BUS_OP_MODE_422DDR,
    RX_BUS_OP_MODE_444SDR,
    RX_BUS_OP_MODE_444DDR,
    RX_BUS_OP_MODE_422SDR,
    RX_BUS_OP_MODE_ADI_CM
} RX_BUS_OP_MODE;

typedef enum 
{
    RX_BUS_OP_CH_GBR = 0,
    RX_BUS_OP_CH_GRB,
    RX_BUS_OP_CH_BGR,
    RX_BUS_OP_CH_RGB,
    RX_BUS_OP_CH_BRG,
    RX_BUS_OP_CH_RBG
} RX_BUS_OP_CH;

typedef struct
{
    RX_BUS_BIT_WIDTH  BitWidth;
    RX_BUS_OP_MODE    Format;
    RX_BUS_MODE       Mode;
    RX_BUS_OP_CH      ChOrder;
    BOOL_T           CrCbSwap;
    BOOL_T           BitReorder;   
} RX_PIX_BUS_INFO;

typedef enum
{
    RX_HS_VS_DE = 0,                   
    RX_HS_VS_FIELD                  
} TV_SYNC_TYPE;

typedef enum
{
    RX_1X_CLK = 1,
    RX_2X_CLK,
    RX_0Dot5_CLK,
    RX_90Deg_1X_CLK
} RX_PIX_CLK_FREQ;

typedef struct
{
    RX_PIX_BUS_INFO     PixBusInfo;
    TV_SYNC_TYPE        SyncOpType;
    RX_PIX_CLK_FREQ     PixClkFreqAdj;   
} TV_PIX_IF;

typedef struct
{
    RX_CS_COLOR     RxIpCsExpected;
    RX_CS_COLOR RxOpCsDesired;
    RX_RANGE    RxOpRangeDesired;
    TV_PIX_IF       *RxOpPixelConfig;
    U8_T FpgaChanId;
}APP_VID_PATH_INFO;

//[RD3-160]+
enum eWorkingMode
{
	DEVICE_480_MODE,
	DEVICE_720_MODE,
	DEVICE_4k2k_MODE,
};
//[RD3-160]-

enum eColorModeRX
{
    VIDEO_YUV_FMT,
    VIDEO_RGB_FULL_FMT,
    VIDEO_RGB_LIMIT_FMT,
};

enum ePixelModeRX
{
	SINGLE_PIXEL_MODE,
	DUAL_PIXEL_MODE,
};

enum eVideoTypeRX
{
    VIDEO_RGB_MODE,
    VIDEO_422_MODE,
    VIDEO_444_MODE,
    VIDEO_420_MODE,
};
enum eColorFormatRX
{
	YCbCr_422_10 = 0,
	YCbCr_444_10,
	RGB_444_10,
	YCbCrA_4444_10,
	RGBA_4444_10,
	YCbCr_422_12,
	YCbCr_444_12,
	RGB_444_12,
	XYZ_444_12
};

enum eFrameRateRX
{
	RX_FPS_NONE = 0,
	RX_FPS_2398 = 2,
	RX_FPS_2400,
	RX_FPS_4795,
	RX_FPS_2500,
	RX_FPS_2997,
	RX_FPS_3000,
	RX_FPS_4800,
	RX_FPS_5000,
	RX_FPS_5994,
	RX_FPS_6000
};

enum eRGBtoYUV
{
	y_g_coef = 0,
	y_b_coef,
	y_r_coef,
	y_offset,
	cb_g_coef,
	cb_b_coef,
	cb_r_coef,
	cb_offset,
	cr_g_coef,
	cr_b_coef,
	cr_r_coef,
	cr_offset,

	y_g_coef_s,
	y_b_coef_s,
	y_r_coef_s,
	y_offset_s,
	cb_g_coef_s,
	cb_b_coef_s,
	cb_r_coef_s,
	cb_offset_s,
	cr_g_coef_s,
	cr_b_coef_s,
	cr_r_coef_s,
	cr_offset_s
};

enum eYUVtoRGB
{
	g_y_coef = 0,
	g_cb_coef,
	g_cr_coef,
	y1_offset,
	b_y_coef,
	b_cb_coef,
	b_cr_coef,
	cb1_offset,
	r_y_coef,
	r_cb_coef,
	r_cr_coef,
	cr1_offset,

	g_y_coef_s,
	g_cb_coef_s,
	g_cr_coef_s,
	y1_offset_s,
	b_y_coef_s,
	b_cb_coef_s,
	b_cr_coef_s,
	cb1_offset_s,
	r_y_coef_s,
	r_cb_coef_s,
	r_cr_coef_s,
	cr1_offset_s,

	y2_offset,
	cb2_offset,
	cr2_offset,
	y2_offset_s,
	cb2_offset_s,
	cr2_offset_s
};

typedef enum 
{
    RX_OUT_YUV601,
    RX_OUT_YUV709,
    RX_OUT_RGB_LIMITED,
    RX_OUT_RGB_FULL,
}rx_out_colorspace_e;

typedef struct
{
    int device_index;
    rx_out_colorspace_e out_colorspace;
}rx_out_ctrl_t;


typedef enum
{
    VSYNC_POS_MASK=(0x1<<0),
    HSYNC_POS_MASK=(0x1<<1),
}polarity_mask_e;

typedef struct
{
    polarity_mask_e  polarities;
    U64_T   pixelclock;
    U32_T   hfrontporch;
    U32_T   hsync;
    U32_T   hbackporch;
    U32_T   vfrontporch;
    U32_T   vsync;
    U32_T   vbackporch;
    U32_T   il_vfrontporch;
    U32_T   il_vsync;
    U32_T   il_vbackporch;
}detail_timing_t;

typedef struct
{
    U32_T   width;
    U32_T   height;
    BOOL_T  interlaced;
    U32_T   framerate;
    detail_timing_t detail;
}video_timing_t;

// 7601 working mode, 
//  0 - 7601 working on SD video format
//  1 - 7601 working on HD video format
typedef enum //eConfigADV7601
{
    hdmi_SD_MODE,
    hdmi_HD_MODE,
}hdmi_out_format_e;

typedef struct _hdmi_AUDIO_SOURCE_SELECTOR
{
    U8_T group_sel;//0 or 1
    U8_T ch_num;   //0 ~ 3
} hdmi_AUDIO_SOURCE_SELECTOR;
/////////////////////////////////////


typedef struct{
    U8_T   id_4x3;
    U8_T   id_16x9;
}CEA_ID;

typedef struct
{
     // IT6604 reference 
     U32_T        h_active ;       // horizontal total line
     U32_T        v_active ;       // vertical total line    
     U32_T        h_total ;        // horizontal active line
     U32_T        v_total ;        // vertical active line 
     //LONG        PCLK ;
     U32_T        pclk ;
     //U8_T        xCnt ;
     U32_T        xcnt ;
     U8_T        scan_mode ;
     U8_T        v_polarity ;
     U8_T        h_polarity ;

     // self defined
     U32_T        rate ;          // frame rate
     U32_T  qp_in_ctrl ;     // [Ian_022] : add the control setting
     U32_T  qp_in_res  ;     // [Ian_022] : add the resolution setting
     U32_T  qp_in_sync ;     // [Ian_022] : add the sync setting
     
     //U8_T forced ;             // [Ian_022] : comment // [Ian_018] : 0 = disable, 
                                 //                        1 = enable forced 50/60p encode
} video_info_t ;

typedef struct HDMI_CEA861ID
{
	CEA_ID cea_861_id;
	video_info_t vid_info;
} HDMI_CEA861ID;

typedef enum
{
    HDMI_LOCK,
    HDMI_UNLOCK,        
    HDMI_AUDIO_CHG,       
    HDMI_RESUME,      
    //hdmi_HDCP,        
}hdmi_event_e;


typedef struct
{
	U8_T working_mode;
	U8_T color_space_mode;
	U8_T sampling_mode;
	U8_T pixel_mode;
	U32_T packet_repetition;
	U32_T packet_video_lock;
	U32_T packet_width;
	U32_T packet_height;
	U32_T packet_interlace;
	U32_T packet_frame_rate;
	U32_T rx_frame_rate;

	U8_T old_working_mode;
	U8_T old_color_space_mode;
	U8_T old_sampling_mode;
	U8_T old_pixel_mode;
	U32_T old_packet_repetition;
	U32_T old_packet_video_lock;
	U32_T old_packet_width;
	U32_T old_packet_height;
	U32_T old_packet_interlace;
	U32_T old_packet_frame_rate;
	U32_T old_rx_frame_rate;
	
	U8_T working_mode_in;
	U8_T working_mode_out;
	U32_T cs_fourcc_out;
	U8_T pixel_fmt_out;
	U8_T color_space_mode_in; // VIDEO_YUV_FMT // VIDEO_RGB_FULL_FMT // VIDEO_RGB_LIMIT_FMT
}rx_packetinfo_t;

typedef struct
{
    U32_T width;
    U32_T height;
    BOOL_T is_interlace;
    U32_T framerate;
    U32_T denominator;
    U32_T pixel_clock;
    rx_out_colorspace_e colorspace;
	U8_T working_mode;
	U8_T color_space_mode;
	U8_T sampling_mode;
}rx_frameinfo_t;

//[RD3-148]+
enum rx_rgb_color_rang_mode
{
	RGB_CRM_LIMITED = 0,
	RGB_CRM_FULL	= 1,
	RGB_CRM_AUTO	= 2,
	RGB_CRM_UNKNOWN	= 0xff
};
//[RD3-148]-


#ifdef __cplusplus
}
#endif

#endif /* RX_SHARE_H */

