/*===================================================================
 * Copyright(c) AVerMedia TECHNOLOGIES, Inc. 2017
 * All rights reserved
 * =================================================================
 * typedef.h
 *
 *  Created on: Apr 15, 2017
 *      Author: 
 *      Version:
 * =================================================================
 */

#ifndef TYPEDEF_H
#define TYPEDEF_H

#ifdef __cplusplus
extern "C" {
#endif

#ifndef NULL
#define NULL ((void *)0)
#endif    

#define Bit(x) (1<<(x))
#define BITMASK(x) ((1<<(x))-1) 

#define NA 0xff

#define XIL_COMPONENT_IS_READY     0x11111111U  
#define XIL_COMPONENT_IS_STARTED   0x22222222U 

#ifndef offsetof    
#define offsetof(TYPE, MEMBER)  ((unsigned long )&((TYPE *)0)->MEMBER)    
#endif    
#ifndef container_of  
#define container_of(ptr, type, member) ({                      \
         const typeof( ((type *)0)->member ) *__mptr = (ptr);    \
         (type *)( (char *)__mptr - offsetof(type,member) );})    
#endif    

#define TARGET_RT_BIG_ENDIAN 1
#if TARGET_RT_BIG_ENDIAN
#define FourCC2Str(fourcc) (const char[]){*((char*)&fourcc), *(((char*)&fourcc)+1), *(((char*)&fourcc)+2), *(((char*)&fourcc)+3),0}
#else
#define FourCC2Str(fourcc) (const char[]){*(((char*)&fourcc)+3), *(((char*)&fourcc)+2), *(((char*)&fourcc)+1), *(((char*)&fourcc)+0),0}
#endif

typedef unsigned char U8_T;
typedef char S8_T;
typedef unsigned short U16_T;
typedef short S16_T;
typedef unsigned int U32_T;
typedef int S32_T;
typedef unsigned long SIZE_T;
typedef unsigned long long U64_T;
typedef long long S64_T;

#if !defined(LONG) || !defined(ULONG)
typedef long LONG;
typedef unsigned long ULONG;
#endif

#ifndef intptr_t
typedef long intptr_t;
#endif

#ifndef uintptr_t
typedef unsigned long uintptr_t;
#endif

typedef intptr_t INTPTR;
typedef uintptr_t UINTPTR;

typedef enum 
{
    AVER_FALSE,
    AVER_TRUE,
} BOOL_T;

typedef void *handle_t;
typedef void (*XInterruptHandler) (void *InstancePtr);
typedef void (*XExceptionHandler) (void *InstancePtr);


#ifdef __cplusplus
}
#endif

#endif /* TYPEDEF_H */

