/*===================================================================
 * Copyright(c) AVerMedia TECHNOLOGIES, Inc. 2017
 * All rights reserved
 * =================================================================
 * gpio_model.h
 *
 *  Created on: Apr 15, 2017
 *      Author: 
 *      Version:
 * =================================================================
 */
 
#ifndef __GPIO_H__
#define __GPIO_H__

#define GPIO_CXT_ID fourcc_id('G','P','I','O')


#define    GPIOIC_DIR_IN 0
#define    GPIOIC_DIR_OUT 1
#define    GPIOIC_DIR_UNKNOWN -1


#define    GPIOIC_VALUE_LOW 0
#define    GPIOIC_VALUE_HIGH 1
#define    GPIOIC_VALUE_UNKNOWN -1


typedef struct gpio_ic_ops
{
	int (*set_direction)(void *context, unsigned no,int dir);
	int (*get_direction)(void *context, unsigned no);
	int (*set)(void *context,unsigned no, int value);
	int (*get)(void *context,unsigned no);
}gpio_ic_ops_t;


typedef void *gpio_model_pin_handle_t;
#define GPIO_MODEL_BAD_PIN_HANDLE (void *)NULL

#define    GPIO_MODEL_OK 0
#define    GPIO_MODEL_ERROR_NO_SUCH_NAME -1
#define    GPIO_MODEL_ALREADY_REGISTERED -2
#define    GPIO_MODEL_ALLOC_FAIL -3
#define    GPIO_MODEL_BAD_HANDLE -4

typedef void *gpio_model_handle_t;

gpio_model_handle_t gpio_model_init(cxt_mgr_handle_t cxt_mgr);
int gpio_model_register_ic(gpio_model_handle_t gpio_model_context,const char *gpio_ic_name,gpio_ic_ops_t *ops,void *context);
int gpio_model_unregister_ic(gpio_model_handle_t gpio_model_context,const char *gpio_ic_name);
int gpio_model_register_pin(gpio_model_handle_t gpio_model_context,const char *gpio_ic_name,const char *pin_name,int pin_no);
gpio_model_pin_handle_t gpio_model_request_pin_handle(gpio_model_handle_t gpio_model_context,const char *pin_name);
int gpio_model_pin_set(gpio_model_pin_handle_t handle,int value);
int	gpio_model_pin_get(gpio_model_pin_handle_t handle);
int gpio_model_pin_set_direction(gpio_model_pin_handle_t handle,int dir);
int gpio_model_pin_get_direction(gpio_model_pin_handle_t handle);
void gpio_model_pin_release(gpio_model_pin_handle_t handle);

#endif
